#include "sybdb.h"
#include "dblib.h"
/* #include "fortify.h" */

extern int (*g_dblib_msg_handler)();
extern int (*g_dblib_err_handler)();

/* The next 2 functions will be the reciever for the info and error messages
 * that come from the TDS layer.  The address of this function is passed to
 * the TDS layer in the dbinit function.  This way, when the TDS layer
 * recieves an informational message from the server that it can be dealt with
 * immediately (or so). It takes a pointer to a DBPROCESS, its just that the
 * TDS layer didn't what it really was */
int dblib_handle_info_message(void *aStruct)
{
	DBPROCESS* dbproc = (DBPROCESS*)aStruct;
	TDSSOCKET* tds = dbproc->tds_socket;
	if( tds->msg_info->msg_number > 0 )
	{
		/* now check to see if the user supplied a function, if not ignore the
		 * problem */
		if(g_dblib_msg_handler)
		{
			g_dblib_msg_handler(dbproc,
					tds->msg_info->msg_number,
					tds->msg_info->msg_state,
					tds->msg_info->msg_level, 
					tds->msg_info->message,
					tds->msg_info->server, 
					tds->msg_info->proc_name);
		}
		else
		{
#if 0
			fprintf (stderr, "INFO..No User supplied info msg handler..Msg %d, Level %d, State %d, Server %s, Line %d\n%s\n",
					tds->msg_info->msg_number,
					tds->msg_info->msg_level, 
					tds->msg_info->msg_state,
					tds->msg_info->server, 
					tds->msg_info->line_number,  
					tds->msg_info->message);
#endif
		}

		/* and now clean up the structure for next time */
		tds_reset_msg_info(dbproc->tds_socket);
	}
}

int dblib_handle_err_message(void *aStruct)
{
	DBPROCESS* dbproc = (DBPROCESS*)aStruct;
	TDSSOCKET* tds = dbproc->tds_socket;
	if( tds->msg_info->msg_number > 0 )
	{
		/* now check to see if the user supplied a function, if not ignore the
		 * problem */
		if(g_dblib_err_handler)
		{
			g_dblib_err_handler(dbproc,
					tds->msg_info->msg_level,
					tds->msg_info->msg_number,
					tds->msg_info->msg_state, 
					tds->msg_info->message,
					tds->msg_info->server); 
		}
		else
		{
#if 0
			fprintf (stderr, "ERR..No User supplied err msg handler..Msg %d, Level %d, State %d, Server %s, Line %d\n%s\n",
					tds->msg_info->msg_number,
					tds->msg_info->msg_level, 
					tds->msg_info->msg_state,
					tds->msg_info->server, 
					tds->msg_info->line_number,  
					tds->msg_info->message);
#endif
		}

		/* and now clean up the structure for next time */
		tds_reset_msg_info(dbproc->tds_socket);
	}
}
